/*
 * UNC001 firmware. (c) Unicontrollers, Ltd., 2013
 *
 * Please see the files README, COPYING, LICENSE and WARRANTY
 * for some useful details on the legal status of this code.
 * Visit the site http://www.unicontrollers.com for more info.
 *
 * file print.c
 * Printing functions
 *
 * Written by Andrey V. Stolyarov
 *
 */

/* #include <avr/pgmspace.h> */

#include "unc_prim.h"
#include "misc.h"

#include "print.h"

#ifdef UNC_RS232_SUPPORT
uint8_t force_to_serial = 0;
void print_char(uint8_t c)
{
    global_state_putchar(c);
    if(force_to_serial > 0 ||
        global_configuration.user_config_bytes[1] & 0x02
    ) {
        ser_io_pc(c);
    }
}
#endif

void print_str(const char *s)
{
#if 1
    while(*s)
        print_char(*s++);
#else
    while(pgm_read_byte(s))
        print_char(pgm_read_byte(s++));
#endif
}

void print_hex_byte(uint8_t d)
{
    print_char(hexdigit(d >> 4));
    print_char(hexdigit(d & 0x0f));
}
